## emscripten 2.0.12~dfsg

=== site/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    = -W
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo ""
	@echo "  install    install to emscripte-site directory (set \$$(EMSCRIPTEN_SITE))"

clean:
	rm -rf $(BUILDDIR)/*

install: html
	@ if [ -z "$(EMSCRIPTEN_SITE)" ]; then echo "Please set EMSCRIPTEN_SITE"; exit 1; fi
	rm -rf $(EMSCRIPTEN_SITE)/docs $(EMSCRIPTEN_SITE)/_images $(EMSCRIPTEN_SITE)/_source $(EMSCRIPTEN_SITE)/_start
	cp -R $(BUILDDIR)/html/* $(EMSCRIPTEN_SITE)

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Emscripten.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Emscripten.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Emscripten"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Emscripten"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== tools/websocket_to_posix_proxy/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(websocket_to_posix_proxy)

file(GLOB sourceFiles src/*.cpp src/*.h)

add_executable(websocket_to_posix_proxy ${sourceFiles})

find_package(Threads)
target_link_libraries(websocket_to_posix_proxy ${CMAKE_THREAD_LIBS_INIT})

if (WIN32)
	add_definitions(-D_CRT_SECURE_NO_WARNINGS)
	add_definitions(/wd4200) # "nonstandard extension used: zero-sized array in struct/union"
	target_link_libraries(websocket_to_posix_proxy Ws2_32.lib)
endif()

=== system/lib/libunwind/CMakeLists.txt ===
#===============================================================================
# Setup Project
#===============================================================================

cmake_minimum_required(VERSION 3.4.3)

if (POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW) # Set MACOSX_RPATH=YES by default
endif()

# Add path for custom modules
set(CMAKE_MODULE_PATH
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules"
  ${CMAKE_MODULE_PATH}
  )

if (CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR OR LIBUNWIND_STANDALONE_BUILD)
  project(libunwind LANGUAGES C CXX ASM)

  # Rely on llvm-config.
  set(CONFIG_OUTPUT)
  if(NOT LLVM_CONFIG_PATH)
    find_program(LLVM_CONFIG_PATH "llvm-config")
  endif()
  if (DEFINED LLVM_PATH)
    set(LLVM_INCLUDE_DIR ${LLVM_INCLUDE_DIR} CACHE PATH "Path to llvm/include")
    set(LLVM_PATH ${LLVM_PATH} CACHE PATH "Path to LLVM source tree")
    set(LLVM_MAIN_SRC_DIR ${LLVM_PATH})
    set(LLVM_CMAKE_PATH "${LLVM_PATH}/cmake/modules")
  elseif(LLVM_CONFIG_PATH)
    message(STATUS "Found LLVM_CONFIG_PATH as ${LLVM_CONFIG_PATH}")
    set(CONFIG_COMMAND ${LLVM_CONFIG_PATH} "--includedir" "--prefix" "--src-root")
    execute_process(COMMAND ${CONFIG_COMMAND}
                    RESULT_VARIABLE HAD_ERROR
                    OUTPUT_VARIABLE CONFIG_OUTPUT)
    if (NOT HAD_ERROR)
      string(REGEX REPLACE "[ \t]*[\r\n]+[ \t]*" ";"
             CONFIG_OUTPUT ${CONFIG_OUTPUT})
    else()
      string(REPLACE ";" " " CONFIG_COMMAND_STR "${CONFIG_COMMAND}")
      message(STATUS "${CONFIG_COMMAND_STR}")
      message(FATAL_ERROR "llvm-config failed with status ${HAD_ERROR}")
    endif()

    list(GET CONFIG_OUTPUT 0 INCLUDE_DIR)
    list(GET CONFIG_OUTPUT 1 LLVM_OBJ_ROOT)
    list(GET CONFIG_OUTPUT 2 MAIN_SRC_DIR)

    set(LLVM_INCLUDE_DIR ${INCLUDE_DIR} CACHE PATH "Path to llvm/include")
    set(LLVM_BINARY_DIR ${LLVM_OBJ_ROOT} CACHE PATH "Path to LLVM build tree")
    set(LLVM_MAIN_SRC_DIR ${MAIN_SRC_DIR} CACHE PATH "Path to LLVM source tree")
    set(LLVM_LIT_PATH "${LLVM_PATH}/utils/lit/lit.py")

    # --cmakedir is supported since llvm r291218 (4.0 release)
    execute_process(
      COMMAND ${LLVM_CONFIG_PATH} --cmakedir
      RESULT_VARIABLE HAD_ERROR
      OUTPUT_VARIABLE CONFIG_OUTPUT
      ERROR_QUIET)
    if(NOT HAD_ERROR)
      string(STRIP "${CONFIG_OUTPUT}" LLVM_CMAKE_PATH_FROM_LLVM_CONFIG)
      file(TO_CMAKE_PATH "${LLVM_CMAKE_PATH_FROM_LLVM_CONFIG}" LLVM_CMAKE_PATH)
    else()
      file(TO_CMAKE_PATH "${LLVM_BINARY_DIR}" LLVM_BINARY_DIR_CMAKE_STYLE)
      set(LLVM_CMAKE_PATH "${LLVM_BINARY_DIR_CMAKE_STYLE}/lib${LLVM_LIBDIR_SUFFIX}/cmake/llvm")
    endif()
  else()
    message(WARNING "UNSUPPORTED LIBUNWIND CONFIGURATION DETECTED: "
                    "llvm-config not found and LLVM_MAIN_SRC_DIR not defined. "
                    "Reconfigure with -DLLVM_CONFIG=path/to/llvm-config "
                    "or -DLLVM_PATH=path/to/llvm-source-root.")
  endif()

  if (EXISTS ${LLVM_CMAKE_PATH})
    # Enable warnings, otherwise -w gets added to the cflags by HandleLLVMOptions.
    set(LLVM_ENABLE_WARNINGS ON)
    list(APPEND CMAKE_MODULE_PATH "${LLVM_CMAKE_PATH}")
    include("${LLVM_CMAKE_PATH}/AddLLVM.cmake")
    include("${LLVM_CMAKE_PATH}/HandleLLVMOptions.cmake")
  else()
    message(WARNING "Not found: ${LLVM_CMAKE_PATH}")
  endif()

  set(PACKAGE_NAME libunwind)
  set(PACKAGE_VERSION 11.0.0)
  set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}")
  set(PACKAGE_BUGREPORT "llvm-bugs@lists.llvm.org")

  if (EXISTS ${LLVM_MAIN_SRC_DIR}/utils/lit/lit.py)
    set(LLVM_LIT ${LLVM_MAIN_SRC_DIR}/utils/lit/lit.py)
  else()
    # Seek installed Lit.
    find_program(LLVM_LIT "lit.py" ${LLVM_MAIN_SRC_DIR}/utils/lit
                 DOC "Path to lit.py")
  endif()

  if (LLVM_LIT)
    # Define the default arguments to use with 'lit', and an option for the user
    # to override.
    set(LIT_ARGS_DEFAULT "-sv")
    if (MSVC OR XCODE)
      set(LIT_ARGS_DEFAULT "${LIT_ARGS_DEFAULT} --no-progress-bar")
    endif()
    set(LLVM_LIT_ARGS "${LIT_ARGS_DEFAULT}" CACHE STRING "Default options for lit")

    # On Win32 hosts, provide an option to specify the path to the GnuWin32 tools.
    if (WIN32 AND NOT CYGWIN)
      set(LLVM_LIT_TOOLS_DIR "" CACHE PATH "Path to GnuWin32 tools")
    endif()
  else()
    set(LLVM_INCLUDE_TESTS OFF)
  endif()

  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib${LLVM_LIBDIR_SUFFIX})
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib${LLVM_LIBDIR_SUFFIX})
else()
  set(LLVM_LIT "${CMAKE_SOURCE_DIR}/utils/lit/lit.py")
endif()

#===============================================================================
# Setup CMake Options
#===============================================================================
include(CMakeDependentOption)
include(HandleCompilerRT)

# Define options.
option(LIBUNWIND_BUILD_32_BITS "Build 32 bit libunwind" ${LLVM_BUILD_32_BITS})
option(LIBUNWIND_ENABLE_ASSERTIONS "Enable assertions independent of build mode." ON)
option(LIBUNWIND_ENABLE_PEDANTIC "Compile with pedantic enabled." ON)
option(LIBUNWIND_ENABLE_WERROR "Fail and stop if a warning is triggered." OFF)
option(LIBUNWIND_ENABLE_SHARED "Build libunwind as a shared library." ON)
option(LIBUNWIND_ENABLE_STATIC "Build libunwind as a static library." ON)
option(LIBUNWIND_ENABLE_CROSS_UNWINDING "Enable cross-platform unwinding support." OFF)
option(LIBUNWIND_ENABLE_ARM_WMMX "Enable unwinding support for ARM WMMX registers." OFF)
option(LIBUNWIND_ENABLE_THREADS "Build libunwind with threading support." ON)
option(LIBUNWIND_WEAK_PTHREAD_LIB "Use weak references to refer to pthread functions." OFF)
option(LIBUNWIND_USE_COMPILER_RT "Use compiler-rt instead of libgcc" OFF)
option(LIBUNWIND_INCLUDE_DOCS "Build the libunwind documentation." ${LLVM_INCLUDE_DOCS})
option(LIBUNWIND_USE_FRAME_HEADER_CACHE "Cache frame headers for unwinding. Requires locking dl_iterate_phdr." OFF)

set(LIBUNWIND_LIBDIR_SUFFIX "${LLVM_LIBDIR_SUFFIX}" CACHE STRING
    "Define suffix of library directory name (32/64)")
option(LIBUNWIND_INSTALL_LIBRARY "Install the libunwind library." ON)
cmake_dependent_option(LIBUNWIND_INSTALL_STATIC_LIBRARY
  "Install the static libunwind library." ON
  "LIBUNWIND_ENABLE_STATIC;LIBUNWIND_INSTALL_LIBRARY" OFF)
cmake_dependent_option(LIBUNWIND_INSTALL_SHARED_LIBRARY
  "Install the shared libunwind library." ON
  "LIBUNWIND_ENABLE_SHARED;LIBUNWIND_INSTALL_LIBRARY" OFF)
set(LIBUNWIND_TARGET_TRIPLE "" CACHE STRING "Target triple for cross compiling.")
set(LIBUNWIND_GCC_TOOLCHAIN "" CACHE PATH "GCC toolchain for cross compiling.")
set(LIBUNWIND_SYSROOT "" CACHE PATH "Sysroot for cross compiling.")
set(LIBUNWIND_TEST_LINKER_FLAGS "" CACHE STRING
    "Additional linker flags for test programs.")
set(LIBUNWIND_TEST_COMPILER_FLAGS "" CACHE STRING
    "Additional compiler flags for test programs.")
set(LIBUNWIND_TEST_CONFIG "${CMAKE_CURRENT_SOURCE_DIR}/test/lit.site.cfg.in" CACHE STRING
    "The Lit testing configuration to use when running the tests.")

if (NOT LIBUNWIND_ENABLE_SHARED AND NOT LIBUNWIND_ENABLE_STATIC)
  message(FATAL_ERROR "libunwind must be built as either a shared or static library.")
endif()

# Check that we can build with 32 bits if requested.
if (CMAKE_SIZEOF_VOID_P EQUAL 8 AND NOT WIN32)
  if (LIBUNWIND_BUILD_32_BITS AND NOT LLVM_BUILD_32_BITS) # Don't duplicate the output from LLVM
    message(STATUS "Building 32 bits executables and libraries.")
  endif()
elseif(LIBUNWIND_BUILD_32_BITS)
  message(FATAL_ERROR "LIBUNWIND_BUILD_32_BITS=ON is not supported on this platform.")
endif()

option(LIBUNWIND_HERMETIC_STATIC_LIBRARY
  "Do not export any symbols from the static library." OFF)

#===============================================================================
# Configure System
#===============================================================================

# Add path for custom modules
set(CMAKE_MODULE_PATH
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
    ${CMAKE_MODULE_PATH})

set(LIBUNWIND_COMPILER    ${CMAKE_CXX_COMPILER})
set(LIBUNWIND_SOURCE_DIR  ${CMAKE_CURRENT_SOURCE_DIR})
set(LIBUNWIND_BINARY_DIR  ${CMAKE_CURRENT_BINARY_DIR})

string(REGEX MATCH "[0-9]+\\.[0-9]+(\\.[0-9]+)?" CLANG_VERSION
       ${PACKAGE_VERSION})

if(LLVM_ENABLE_PER_TARGET_RUNTIME_DIR AND NOT APPLE)
  set(LIBUNWIND_LIBRARY_DIR ${LLVM_LIBRARY_OUTPUT_INTDIR}/${LLVM_DEFAULT_TARGET_TRIPLE}/c++)
  set(LIBUNWIND_INSTALL_LIBRARY_DIR lib${LLVM_LIBDIR_SUFFIX}/${LLVM_DEFAULT_TARGET_TRIPLE}/c++)
  if(LIBCXX_LIBDIR_SUBDIR)
    string(APPEND LIBUNWIND_LIBRARY_DIR /${LIBUNWIND_LIBDIR_SUBDIR})
    string(APPEND LIBUNWIND_INSTALL_LIBRARY_DIR /${LIBUNWIND_LIBDIR_SUBDIR})
  endif()
elseif(LLVM_LIBRARY_OUTPUT_INTDIR)
  set(LIBUNWIND_LIBRARY_DIR ${LLVM_LIBRARY_OUTPUT_INTDIR})
  set(LIBUNWIND_INSTALL_LIBRARY_DIR lib${LIBUNWIND_LIBDIR_SUFFIX})
else()
  set(LIBUNWIND_LIBRARY_DIR ${CMAKE_BINARY_DIR}/lib${LIBUNWIND_LIBDIR_SUFFIX})
  set(LIBUNWIND_INSTALL_LIBRARY_DIR lib${LIBUNWIND_LIBDIR_SUFFIX})
endif()

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${LIBUNWIND_LIBRARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${LIBUNWIND_LIBRARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${LIBUNWIND_LIBRARY_DIR})

set(LIBUNWIND_INSTALL_PREFIX "" CACHE STRING "Define libunwind destination prefix.")

set(LIBUNWIND_C_FLAGS "")
set(LIBUNWIND_CXX_FLAGS "")
set(LIBUNWIND_COMPILE_FLAGS "")
set(LIBUNWIND_LINK_FLAGS "")

# Include macros for adding and removing libunwind flags.
include(HandleLibunwindFlags)

#===============================================================================
# Setup Compiler Flags
#===============================================================================

# Get required flags.
add_target_flags_if(LIBUNWIND_BUILD_32_BITS "-m32")

if(LIBUNWIND_TARGET_TRIPLE)
  add_target_flags("--target=${LIBUNWIND_TARGET_TRIPLE}")
elseif(CMAKE_CXX_COMPILER_TARGET)
  set(LIBUNWIND_TARGET_TRIPLE "${CMAKE_CXX_COMPILER_TARGET}")
endif()
if(LIBUNWIND_GCC_TOOLCHAIN)
  add_target_flags("--gcc-toolchain=${LIBUNWIND_GCC_TOOLCHAIN}")
elseif(CMAKE_CXX_COMPILER_EXTERNAL_TOOLCHAIN)
  set(LIBUNWIND_GCC_TOOLCHAIN "${CMAKE_CXX_COMPILER_EXTERNAL_TOOLCHAIN}")
endif()
if(LIBUNWIND_SYSROOT)
  add_target_flags("--sysroot=${LIBUNWIND_SYSROOT}")
elseif(CMAKE_SYSROOT)
  set(LIBUNWIND_SYSROOT "${CMAKE_SYSROOT}")
endif()

if (LIBUNWIND_TARGET_TRIPLE)
  set(TARGET_TRIPLE "${LIBUNWIND_TARGET_TRIPLE}")
endif()

# Configure compiler.
include(config-ix)

if (LIBUNWIND_USE_COMPILER_RT AND NOT LIBUNWIND_HAS_NODEFAULTLIBS_FLAG)
  list(APPEND LIBUNWIND_LINK_FLAGS "-rtlib=compiler-rt")
endif()

add_compile_flags_if_supported(-Werror=return-type)

# Get warning flags
add_compile_flags_if_supported(-W)
add_compile_flags_if_supported(-Wall)
add_compile_flags_if_supported(-Wchar-subscripts)
add_compile_flags_if_supported(-Wconversion)
add_compile_flags_if_supported(-Wmismatched-tags)
add_compile_flags_if_supported(-Wmissing-braces)
add_compile_flags_if_supported(-Wnewline-eof)
add_compile_flags_if_supported(-Wno-unused-function)
add_compile_flags_if_supported(-Wshadow)
add_compile_flags_if_supported(-Wshorten-64-to-32)
add_compile_flags_if_supported(-Wsign-compare)
add_compile_flags_if_supported(-Wsign-conversion)
add_compile_flags_if_supported(-Wstrict-aliasing=2)
add_compile_flags_if_supported(-Wstrict-overflow=4)
add_compile_flags_if_supported(-Wunused-parameter)
add_compile_flags_if_supported(-Wunused-variable)
add_compile_flags_if_supported(-Wwrite-strings)
add_compile_flags_if_supported(-Wundef)

if (LIBUNWIND_ENABLE_WERROR)
  add_compile_flags_if_supported(-Werror)
  add_compile_flags_if_supported(-WX)
else()
  add_compile_flags_if_supported(-Wno-error)
  add_compile_flags_if_supported(-WX-)
endif()

if (LIBUNWIND_ENABLE_PEDANTIC)
  add_compile_flags_if_supported(-pedantic)
endif()

# Get feature flags.
# Exceptions
# Catches C++ exceptions only and tells the compiler to assume that extern C
# functions never throw a C++ exception.

=== tests/cmake/cmake_with_emval/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(cmake_with_emval)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

if (NO_GNU_EXTENSIONS)
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

add_executable(cmake_with_emval main.cpp)

=== tests/cmake/cpp_lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(cpp_library)

SET(CPP_LIBRARY_TYPE "SHARED" CACHE STRING "Library type to build")
SET_PROPERTY(CACHE CPP_LIBRARY_TYPE PROPERTY STRINGS STATIC SHARED)

add_library( cpp_lib ${CPP_LIBRARY_TYPE} lib.cpp)
em_link_js_library(cpp_lib "lib.js")

=== tests/cmake/static_lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(static_library)

# Test mode that checks that it's possible to override the file suffix (independent of whether ar archive or LLVM bitcode file is created)
# Note that "-DCMAKE_STATIC_LIBRARY_SUFFIX=foo" cannot be passed to CMake from command line to override the suffix, but changing it needs
# to happen in the CMakeLists.txt file itself. (this is likely due to CMake internal script evaluation order(?))
if (SET_FAKE_SUFFIX_IN_PROJECT)
	set(CMAKE_STATIC_LIBRARY_SUFFIX ".somecustomsuffix")

	# Also check that we can control the prefix. Setting this to an empty string can be useful to get rid of the "lib" prefix that gets added by default.
	set(CMAKE_STATIC_LIBRARY_PREFIX "myprefix_")
endif()

add_library(static_lib STATIC lib.cpp)

=== tests/cmake/stdproperty/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
project(helloworld)

add_executable(helloworld main.cpp)

set_property(TARGET helloworld PROPERTY CXX_STANDARD_REQUIRED ON)
set_property(TARGET helloworld PROPERTY CXX_STANDARD 11)

# Items marked with '***' are tested to be identical across CMake configures with Emscripten Clang when targeting native vs Emscripten.

message(STATUS "*** CMAKE_C_COMPILER_VERSION is ${CMAKE_C_COMPILER_VERSION}")
message(STATUS "*** CMAKE_CXX_COMPILER_VERSION is ${CMAKE_CXX_COMPILER_VERSION}")
message(STATUS "CMAKE_C_COMPILER_TARGET is ${CMAKE_C_COMPILER_TARGET}")
message(STATUS "CMAKE_CXX_COMPILER_TARGET is ${CMAKE_CXX_COMPILER_TARGET}")
message(STATUS "CMAKE_C_PLATFORM_ID is ${CMAKE_C_PLATFORM_ID}")
message(STATUS "CMAKE_CXX_PLATFORM_ID is ${CMAKE_CXX_PLATFORM_ID}")

message(STATUS "*** CMAKE_C_COMPILE_FEATURES is ${CMAKE_C_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_C90_COMPILE_FEATURES is ${CMAKE_C90_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_C99_COMPILE_FEATURES is ${CMAKE_C99_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_C11_COMPILE_FEATURES is ${CMAKE_C11_COMPILE_FEATURES}")

message(STATUS "*** CMAKE_CXX_COMPILE_FEATURES is ${CMAKE_CXX_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_CXX98_COMPILE_FEATURES is ${CMAKE_CXX98_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_CXX11_COMPILE_FEATURES is ${CMAKE_CXX11_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_CXX14_COMPILE_FEATURES is ${CMAKE_CXX14_COMPILE_FEATURES}")
message(STATUS "*** CMAKE_CXX17_COMPILE_FEATURES is ${CMAKE_CXX17_COMPILE_FEATURES}")

=== tests/cmake/target_html/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(hello_world_gles)

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../cpp_lib ${CMAKE_CURRENT_BINARY_DIR}/cpp_lib)

file(GLOB sourceFiles ../../hello_world_gles.c)

if (CMAKE_BUILD_TYPE STREQUAL Debug)
	SET(linkFlags "")
else() # Either MinSizeRel, RelWithDebInfo or Release, all which run with optimizations enabled.
	SET(linkFlags "-O2")
endif()

if (NOT CMAKE_AR OR NOT EXISTS "${CMAKE_AR}")
	message(FATAL_ERROR "CMAKE_AR='${CMAKE_AR}' does not exist for Emscripten toolchain!")
endif()

if (NOT CMAKE_RANLIB OR NOT EXISTS "${CMAKE_RANLIB}")
	message(FATAL_ERROR "CMAKE_RANLIB='${CMAKE_RANLIB}' does not exist for Emscripten toolchain!")
endif()

if (NOT CMAKE_C_COMPILER OR NOT EXISTS "${CMAKE_C_COMPILER}")
	message(FATAL_ERROR "CMAKE_C_COMPILER='${CMAKE_C_COMPILER}' does not exist for Emscripten toolchain!")
endif()

if (NOT CMAKE_CXX_COMPILER OR NOT EXISTS "${CMAKE_CXX_COMPILER}")
	message(FATAL_ERROR "CMAKE_CXX_COMPILER='${CMAKE_CXX_COMPILER}' does not exist for Emscripten toolchain!")
endif()

if (WIN32)
	message(FATAL_ERROR "WIN32 should not be defined when cross-compiling!")
endif()

if (APPLE)
	message(FATAL_ERROR "APPLE should not be defined when cross-compiling!")
endif()

if (NOT EMSCRIPTEN)
	message(FATAL_ERROR "EMSCRIPTEN should be defined when cross-compiling!")
endif()

if (NOT CMAKE_C_SIZEOF_DATA_PTR)
	message(FATAL_ERROR "CMAKE_C_SIZEOF_DATA_PTR was not defined!")
endif()

# with NO_DEFAULT_PATH + ONLY_CMAKE_FIND_ROOT_PATH, we ensure that
# only ${CMAKE_FIND_ROOT_PATH}/include will be searched for
# emscripten/emscripten.h
find_path(EMSCRIPTEN_INCLUDE_DIR emscripten/emscripten.h
	PATHS /include
	NO_DEFAULT_PATH
	ONLY_CMAKE_FIND_ROOT_PATH
	)

if(NOT EMSCRIPTEN_INCLUDE_DIR)
	message(FATAL_ERROR "emscripten.h could not be found! Is CMAKE_FIND_ROOT_PATH='${CMAKE_FIND_ROOT_PATH}' correct?")
endif()

include(CheckIncludeFile)

check_include_file(stdlib.h HAVE_STDLIB_H)
if (NOT HAVE_STDLIB_H)
	message(FATAL_ERROR "CMake script check_include_file failed! Could not find stdlib.h via it!")
endif()

# Artificially make up a long command line. This tests that long command lines work when passed to check_include_file().
# This fails on Windows with CMake 3.2.0 with mingw32-make (GNU make 4.0) and older. Upgrade to CMake 3.3.1 to fix.
set(CMAKE_C_FLAGS "-fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char -fsigned-char")

check_include_file(sys/types.h HAVE_SYS_TYPES_H)
if (NOT HAVE_SYS_TYPES_H)
	message(FATAL_ERROR "CMake script check_include_file failed! Could not find sys/types.h via it!")
endif()

if (NOT CMAKE_EXECUTABLE_SUFFIX STREQUAL ".js")
	message(FATAL_ERROR "The default suffix for building executables should be .js!")
endif()
SET(CMAKE_EXECUTABLE_SUFFIX ".html")

# CMake built-in check_include_file() macro interacts with CMAKE_EXECUTABLE_SUFFIX, so make sure it works after user changes that.

check_include_file(math.h HAVE_MATH_H)
if (NOT HAVE_MATH_H)
	message(FATAL_ERROR "CMake script check_include_file failed! Could not find math.h via it!")
endif()

add_executable(hello_world_gles ${sourceFiles})
target_link_libraries(hello_world_gles cpp_lib)
set_target_properties(hello_world_gles PROPERTIES LINK_FLAGS "${linkFlags}")

=== tests/cmake/target_js/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(test_cmake)

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../cpp_lib ${CMAKE_CURRENT_BINARY_DIR}/cpp_lib)

file(GLOB sourceFiles main.cpp)

file(GLOB preJsFiles pre*.js)
file(GLOB postJsFiles post*.js)
file(GLOB libraryJsFiles jslibrary*.js)

if (CMAKE_BUILD_TYPE STREQUAL Debug)
	SET(linkFlags "-g4 -s NO_EXIT_RUNTIME=1")
else() # Either MinSizeRel, RelWithDebInfo or Release, all which run with optimizations enabled.
	SET(linkFlags "-O2 -s NO_EXIT_RUNTIME=1")
endif()

# Ensure synchronous startup for this test, whose output expects it
SET(linkFlags "${linkFlags} -s WASM_ASYNC_COMPILATION=0")

# Test that the CMake-provided macro check_function_exists() works.
include(CheckFunctionExists)
check_function_exists("strtod" HAVE_STRTOD)
if (NOT HAVE_STRTOD)
	message(FATAL_ERROR "CMake script check_function_exists failed! Could not detect if strtod() is supported!")
endif()

# Test that the CMake-provided macro check_function_exists() is not actually trivially returning true for everything.
check_function_exists("some_nonexisting_function" HAVE_NONEXISTING_FUNCTION)
if (${HAVE_NONEXISTING_FUNCTION})
	message(FATAL_ERROR "CMake script check_function_exists failed! It erroneously reports that function some_nonexisting_function() would exist!")
endif()

# Test that the CMake-provided macro check_include_file() works.
include(CheckIncludeFile)
check_include_file(stdlib.h HAVE_STDLIB_H)
if (NOT HAVE_STDLIB_H)
	message(FATAL_ERROR "CMake script check_include_file failed! Could not find stdlib.h via it!")
endif()

# Test that the CMake-provided macro check_include_file() is not actually trivially returning true for everything.
check_include_file(some_nonexisting_include.h HAVE_NONEXISTING_INCLUDE_H)
if (${HAVE_NONEXISTING_INCLUDE_H})
	message(FATAL_ERROR "CMake script check_include_file failed! It erroneously reports that the C header some_nonexisting_include.h would exist!")
endif()

if (NOT CMAKE_EXECUTABLE_SUFFIX STREQUAL ".js")
	message(FATAL_ERROR "The default suffix for building executables should be .js!")
endif()

# CMake built-in check_include_file() macro interacts with CMAKE_EXECUTABLE_SUFFIX, so make sure it works after user changes that.

check_include_file(math.h HAVE_MATH_H)
if (NOT HAVE_MATH_H)
	message(FATAL_ERROR "CMake script check_include_file failed! Could not find math.h via it!")
endif()

if (WIN32)
	message(FATAL_ERROR "WIN32 should not be defined when cross-compiling!")
endif()

if (APPLE)
	message(FATAL_ERROR "APPLE should not be defined when cross-compiling!")
endif()

if (NOT EMSCRIPTEN)
	message(FATAL_ERROR "EMSCRIPTEN should be defined when cross-compiling!")
endif()

if (NOT CMAKE_C_SIZEOF_DATA_PTR)
	message(FATAL_ERROR "CMAKE_C_SIZEOF_DATA_PTR was not defined!")
endif()

include(TestBigEndian)
test_big_endian(endian_result)
if (NOT ${endian_result} EQUAL 0)
        message(FATAL_ERROR "TEST_BIG_ENDIAN did not return 0!")
endif()

# Requires CMAKE_CROSSCOMPILING_EMULATOR support.
if(${CMAKE_VERSION} VERSION_GREATER 3.2.20150502)
  include(CheckTypeSize)
  check_type_size("int" int_size)
  if (NOT ${int_size} EQUAL 4)
          message(FATAL_ERROR "CHECK_TYPE_SIZE with int did not return 4!")
  endif()
endif()

add_executable(test_cmake ${sourceFiles})
target_link_libraries( test_cmake cpp_lib)

# GOTCHA: If your project has custom link flags, these must be set *before* calling any of the em_link_xxx functions!
set_target_properties(test_cmake PROPERTIES LINK_FLAGS "${linkFlags}")

message(STATUS "js libs '${libraryJsFiles}'")
# To link .js files using the --js-library flag, use the following helper function.
em_link_js_library(test_cmake ${libraryJsFiles})

# To link .js files using the --pre-js flag, use the following helper function.
em_link_pre_js(test_cmake ${preJsFiles})

# To link .js files using the --post-js flag, use the following helper function.
em_link_post_js(test_cmake ${postJsFiles})

=== tests/cmake/target_library/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

project(test_cmake)

add_subdirectory(${CMAKE_CURRENT_SOURCE_DIR}/../cpp_lib ${CMAKE_CURRENT_BINARY_DIR}/cpp_lib)

option(BUILD_SHARED_LIBS "Build with shared libraries." OFF) 

if (CMAKE_BUILD_TYPE STREQUAL Debug)
	SET(linkFlags "-g4")
else() # Either MinSizeRel, RelWithDebInfo or Release, all which run with optimizations enabled.
	SET(linkFlags "-O2")
endif()

set(MAX_SRC_FILE_INDEX 30)
SET(TEST_SRC_FILE_BASE_NAME "this_is_a_test_src_file_with_a_quite_lengthy_name_to_simulate_very_long_command_line_length_problems_on_windows_")


foreach(i RANGE ${MAX_SRC_FILE_INDEX})
	set (TEST_FUNCTION_NAME "FooBar_${i}")
	configure_file("srcfile.cmake" "${TEST_SRC_FILE_BASE_NAME}${i}.c")
	configure_file("srcfile.cmake" "${TEST_SRC_FILE_BASE_NAME}${i}.cpp")
	list(APPEND TEST_SOURCES "${TEST_SRC_FILE_BASE_NAME}${i}.c" "${TEST_SRC_FILE_BASE_NAME}${i}.cpp")
endforeach()

add_library(test_cmake ${TEST_SOURCES})
target_link_libraries(test_cmake cpp_lib)

if (WIN32)
	message(FATAL_ERROR "WIN32 should not be defined when cross-compiling!")
endif()

if (APPLE)
	message(FATAL_ERROR "APPLE should not be defined when cross-compiling!")
endif()

if (NOT EMSCRIPTEN)
	message(FATAL_ERROR "EMSCRIPTEN should be defined when cross-compiling!")
endif()

if (NOT CMAKE_C_SIZEOF_DATA_PTR)
	message(FATAL_ERROR "CMAKE_C_SIZEOF_DATA_PTR was not defined!")
endif()

# GOTCHA: If your project has custom link flags, these must be set *before* calling any of the em_link_xxx functions!
set_target_properties(test_cmake PROPERTIES LINK_FLAGS "${linkFlags}")

=== tests/third_party/box2d/Makefile ===
# Makefile for generating a Box2D library using Emscripten.

O = Box2D
OBJECTS = \
  $(O)/Collision/b2BroadPhase.o \
  $(O)/Collision/b2CollideCircle.o \
  $(O)/Collision/b2CollideEdge.o \
  $(O)/Collision/b2CollidePolygon.o \
  $(O)/Collision/b2Collision.o \
  $(O)/Collision/b2Distance.o \
  $(O)/Collision/b2DynamicTree.o \
  $(O)/Collision/b2TimeOfImpact.o \
  $(O)/Collision/Shapes/b2ChainShape.o \
  $(O)/Collision/Shapes/b2CircleShape.o \
  $(O)/Collision/Shapes/b2EdgeShape.o \
  $(O)/Collision/Shapes/b2PolygonShape.o \
  $(O)/Common/b2BlockAllocator.o \
  $(O)/Common/b2Draw.o \
  $(O)/Common/b2Math.o \
  $(O)/Common/b2Settings.o \
  $(O)/Common/b2StackAllocator.o \
  $(O)/Common/b2Timer.o \
  $(O)/Dynamics/b2Body.o \
  $(O)/Dynamics/b2ContactManager.o \
  $(O)/Dynamics/b2Fixture.o \
  $(O)/Dynamics/b2Island.o \
  $(O)/Dynamics/b2World.o \
  $(O)/Dynamics/b2WorldCallbacks.o \
  $(O)/Dynamics/Contacts/b2ChainAndCircleContact.o \
  $(O)/Dynamics/Contacts/b2ChainAndPolygonContact.o \
  $(O)/Dynamics/Contacts/b2CircleContact.o \
  $(O)/Dynamics/Contacts/b2Contact.o \
  $(O)/Dynamics/Contacts/b2ContactSolver.o \
  $(O)/Dynamics/Contacts/b2EdgeAndCircleContact.o \
  $(O)/Dynamics/Contacts/b2EdgeAndPolygonContact.o \
  $(O)/Dynamics/Contacts/b2PolygonAndCircleContact.o \
  $(O)/Dynamics/Contacts/b2PolygonContact.o \
  $(O)/Dynamics/Joints/b2DistanceJoint.o \
  $(O)/Dynamics/Joints/b2FrictionJoint.o \
  $(O)/Dynamics/Joints/b2GearJoint.o \
  $(O)/Dynamics/Joints/b2Joint.o \
  $(O)/Dynamics/Joints/b2MouseJoint.o \
  $(O)/Dynamics/Joints/b2PrismaticJoint.o \
  $(O)/Dynamics/Joints/b2PulleyJoint.o \
  $(O)/Dynamics/Joints/b2RevoluteJoint.o \
  $(O)/Dynamics/Joints/b2RopeJoint.o \
  $(O)/Dynamics/Joints/b2WeldJoint.o \
  $(O)/Dynamics/Joints/b2WheelJoint.o \
  $(O)/Rope/b2Rope.o

all: box2d.a

%.o: %.cpp
	$(CXX) $(CFLAGS) -I. $< -o $@ -O2 -c -fno-exceptions -fno-rtti

box2d.a: $(OBJECTS)
	$(AR) rvs $@ $(OBJECTS)

clean:
	rm box2d.a

=== tests/third_party/cube2hash/Makefile ===
all: libcube2hash.a

libcube2hash.a: cube2crypto.o tiger.o hashstring.o
	$(AR) rcs $@ $^

hashstring.o: hashstring.cpp
	$(CXX) -c $^ -o $@

cube2crypto.o: cube2crypto.c cube2crypto.h
	$(CC) -c $< -o $@

tiger.o: tiger.c tiger.h
	$(CC) -c $< -o $@

=== debian/changelog ===
emscripten (2.0.12~dfsg-2) unstable; urgency=medium

  * build documentation;
    build-depend on dh-sequence-sphinxdoc python3-sphinx;
    closes: bug#987454, thanks to Adrian Bunk
  * gbp config: set debian-branch=debian/sid
  * add patch 2012 to avoid privacy breach in documentation

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 02 May 2021 18:34:23 +0200

emscripten (2.0.12~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update source-only part of upstream source-map script
  * unfuzz patches
  * update testsuite coverage

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 24 Jan 2021 14:04:06 +0100

emscripten (2.0.11~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update source-only part of upstream source-map script
  * copyright: tighten coverage of Public-Domain files
  * add patch 2010 to avoid npm during build
  * unfuzz patches
  * update testsuite coverage

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 24 Jan 2021 14:16:47 +0100

emscripten (2.0.10~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release;
    closes: bug#979405, thanks to Andreas Beckmann

  [ Jonas Smedegaard ]
  * update source-only part of upstream source-map script
  * copyright: update coverage
  * drop patches 1003 1006 obsoleted by upstream changes
  * update and unfuzz patches
  * update testsuite coverage;
    closes: bug#976520, thanks to Lucas Nussbaum
  * copyright: update coverage
  * tighten build-dependency on binaryen

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 24 Jan 2021 10:16:41 +0100

emscripten (2.0.8~dfsg1-12) unstable; urgency=medium

  * drop patch 2010 (llvm 11 is now default);
    unfuzz patch 2011
  * (build-)depend (only) on non-version clang lld llvm

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 05 Dec 2020 02:08:09 +0100

emscripten (2.0.8~dfsg1-11) unstable; urgency=medium

  * fix patch 1007 and test exclude lists

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 30 Nov 2020 13:33:11 +0100

emscripten (2.0.8~dfsg1-10) unstable; urgency=medium

  * improve testsuite coverage:
    + add patch 1007 to support skipping closure-compiler in tests,
      stop excluding whole test files with closure-compiler tests,
      and instead skip closure-compiler in tests
    + add patch 1008 to avoid hardcoding tool name,
      and stop excluding test files failing with versioned LLVM
  * unfuzz patch 2007
  * declare compliance with Debian Policy 4.5.1
  * use dpkg make snippet to resolve parallel builds
  * copyright:
    + fix cover file licensed bzip2-1.0.6
    + fix use license shortname LGPL-2+ for unversioned licensing
      (not LGPL-1+ because that version does not exist)
    + fix add license sections for LGPL-2.1 LGPL-3
  * override more License-Reference lintian warnings
  * fix override double-wildcard lintian warnings

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 29 Nov 2020 15:47:38 +0100

emscripten (2.0.8~dfsg1-9) unstable; urgency=medium

  * Revert to (build-)depend on llvm-11 or llvm
    (not llvm-11-runtime or llvm-runtime)
  * update git-buildpackage config to use debian branch debian/sid

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 17 Nov 2020 20:18:50 +0100

emscripten (2.0.8~dfsg1-8) unstable; urgency=medium

  * copyright: tighten coverage;
    closes: bug#939477, thanks to Matthias Klose
  * reduce testsuite coverage:
    + stop test all JS engines
      (documented as testing engines more than this code)
    + skip slow tests
  * (build-)depend on llvm-11-runtime or llvm-runtime
    (not llvm-11 or llvm)

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 17 Nov 2020 14:33:39 +0100

emscripten (2.0.8~dfsg1-7) unstable; urgency=medium

  * fix avoid check closure-compiler related tests

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 04 Nov 2020 14:15:50 +0100

emscripten (2.0.8~dfsg1-6) unstable; urgency=medium

  * check wasm2js* modes only in experimental,
    as they fail with BlockingIOError

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 04 Nov 2020 11:55:26 +0100

emscripten (2.0.8~dfsg1-5) unstable; urgency=medium

  * check tests in more chunks,
    to try mitigate log loss
    from "write could not complete without blocking" issues
  * fix negative check for wasm2c
    (not repeat check for succeeding tests)

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 04 Nov 2020 03:36:37 +0100

emscripten (2.0.8~dfsg1-4) experimental; urgency=medium

  * drop obsolete lintian overrides
  * extract metadata from (not skip) wav files
  * add patch 1006
    to have testsuite respect LLVM_ADD_VERSION for llvm-dwarfdump
  * tighten check of failing tests
  * build-depend on fonts-liberation
  * extend patch 1004 to cover closure-compiler
  * add patch 2010
    to detect and use non-default llvm-11 by default
  * add patch 2011
    to detect and use system shared binaryen

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 04 Nov 2020 00:12:01 +0100

emscripten (2.0.8~dfsg1-3) experimental; urgency=medium

  * tighten build-time check to execute in fewer larger batches
  * fix build-depend on (not only suggest) scons
  * skip check of tests failing in mode other
  * check tests in modes wasm* now succeeding
  * explicitly state modes to check,
    and skip avoided modes also in experimental negative check
  * skip check tests needing node module wasm2c
  * support DEB_BUILD_OPTIONS=parallel,
    and always use a single core for experimental failure check

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 03 Nov 2020 16:12:42 +0100

emscripten (2.0.8~dfsg1-2) experimental; urgency=medium

  * copyright:
    + fix drop duplicate Files section
    + fix drop obsolete Files sections
  * avoid strict mode causing multiple failures
  * avoid a test failing in mode wasm1

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 03 Nov 2020 03:58:47 +0100

emscripten (2.0.8~dfsg1-1) experimental; urgency=medium

  * repackage source tarball:
    + avoid convenience code copies:
      - python module ply (packaged separately)
      - Java Native Interface forked with added emjvm.js


=== debian/control ===
Source: emscripten
Section: devel
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders:
 Jonas Smedegaard <dr@jones.dk>,
Build-Depends:
 binaryen (>= 98) <!nocheck>,
 clang (>= 1:11.0) <!nocheck>,
 cmake <!nocheck>,
 eslint <!nocheck>,
 fonts-liberation <!nocheck>,
 libsimde-dev,
 lld (>= 1:11.0) <!nocheck>,
 llvm (>= 1:11.0) <!nocheck>,
 debhelper-compat (= 12),
 dh-sequence-python3,
 help2man,
 htmlmin <!nocheck>,
 libjs-source-map,
 node-acorn <!nocheck>,
 nodejs <!nocheck>,
 python3,
 python3-numpy <!nocheck>,
 python3-ply <!nocheck>,
 scons <!nocheck>,
 wabt <!nocheck>,
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nocheck>,
 python3-sphinx <!nodoc>,
Standards-Version: 4.5.1
Homepage: http://emscripten.org/
Vcs-Browser: https://salsa.debian.org/js-team/emscripten
Vcs-Git: https://salsa.debian.org/js-team/emscripten.git
Rules-Requires-Root: no

Package: emscripten
Architecture: all
Depends:
 binaryen (>= 99),
 clang (>= 1:11.0),
 lld (>= 1:11.0),
 llvm (>= 1:11.0),
 node-acorn,
 nodejs,
 ${misc:Depends},
 ${python3:Depends},
Recommends:
 libjs-d3,
 python3-numpy,
Suggests:
 adb,
 automake,
 closure-compiler,
 cmake,
 make,
 python3-ply,
 scons,
 wabt,
Description: LLVM-to-JavaScript Compiler
 Emscripten is an LLVM to JavaScript compiler. It takes LLVM bitcode, also
 called LLVM IR (which can be generated from C/C++ using Clang, or any other
 language that can be converted into LLVM bitcode) and compiles that into
 JavaScript, which can be run on the web (or anywhere else JavaScript can run).
 .
 Using Emscripten, you can
   * Compile C and C++ code into JavaScript and run that on the web
   * Run code in languages like Python as well, by compiling CPython from C
     to JavaScript and interpreting code in that on the web
 .
 Some uses of emscripten require additional packages:
  * setting WASM2C requires wabt.
  * emcmake requires cmake.
  * emconfigure may require automake.
  * emmake requires make.
  * emrun option --android requires adb.
  * emscons requires scons.
  * WebIDL Binder requires python3-ply.

Package: emscripten-doc
Section: doc
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Built-Using:
 ${sphinxdoc:Built-Using},
Architecture: all
Description: LLVM-to-JavaScript Compiler
 Emscripten is an LLVM to JavaScript compiler. It takes LLVM bitcode, also
 called LLVM IR (which can be generated from C/C++ using Clang, or any other
 language that can be converted into LLVM bitcode) and compiles that into
 JavaScript, which can be run on the web (or anywhere else JavaScript can run).
 .
 Using Emscripten, you can
   * Compile C and C++ code into JavaScript and run that on the web
   * Run code in languages like Python as well, by compiling CPython from C
     to JavaScript and interpreting code in that on the web
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
-include /usr/share/dpkg/buildopts.mk

# resolve if release is experimental
EXP_RELEASE = $(filter experimental% UNRELEASED,$(DEB_DISTRIBUTION))

DEB_VERSION_UPSTREAM_ORIG = $(firstword $(subst ~,$() ,$(DEB_VERSION_UPSTREAM)))

ifneq (,$(DEB_BUILD_OPTION_PARALLEL))
export EMCC_CORES=$(DEB_BUILD_OPTION_PARALLEL)
endif

EM_OPTS = PATH="$(CURDIR):$$PATH" EM_CACHE="$(CURDIR)/debian/em_cache"
EMCC = $(EM_OPTS) emcc
TESTS_RUNNER = $(EM_OPTS) EMTEST_SKIP_SLOW=1 EMTEST_LACKS_CLOSURE_COMPILER=1 tests/runner.py
# use ccache when available
ifneq (,$(wildcard /usr/bin/ccache))
override_dh_auto_test: export EM_COMPILER_WRAPPER=ccache
endif

# files generated during build
SOURCE_MAP_MIN_JS = src/emscripten-source-map.min.js
NEON_H = system/include/neon/arm_neon.h

# requires third-party tests and EH functions renaming bugfix (see bug#975069)
#  * test_freetype also requires symlinked LiberationSansBold.ttf
#  * test_poppler also requires tests.poppler.paper.pdf
ERRORS_wasm += \
 test_freetype \
 test_lua \
 test_poppler

# requires Emscripten Ports
ERRORS_other += \
 test_bullet \
 test_bullet_autoconf \
 test_bullet_cmake \
 test_bzip2 \
 test_freetype \
 test_libjpeg \
 test_libpng \
 test_sdl2_mixer_wav \
 test_vorbis
FAILS_CERTAIN_other += \
 test_boost_graph

# requires bugfix for LinkError: WebAssembly.instantiate():
# Import #151 module="env" function="__stack_pointer" error:
# imported global does not match the expected mutability
FAILS_wasm += \
 test_dlfcn_alignment_and_zeroing \
 test_dlfcn_basic \
 test_dlfcn_data_and_fptr \
 test_dlfcn_funcs \
 test_dlfcn_handle_alloc \
 test_dlfcn_i64 \
 test_dlfcn_info \
 test_dlfcn_longjmp \
 test_dlfcn_mallocs \
 test_dlfcn_missing \
 test_dlfcn_qsort \
 test_dlfcn_self \
 test_dlfcn_stacks \
 test_dlfcn_unique_sig \
 test_dlfcn_varargs \
 test_dylink_basics \
 test_dylink_class \
 test_dylink_dot_a \
 test_dylink_dso_needed \
 test_dylink_dynamic_cast \
 test_dylink_floats \
 test_dylink_funcpointer \
 test_dylink_funcpointers_wrapper \
 test_dylink_function_pointer_equality \
 test_dylink_global_init \
 test_dylink_global_inits \
 test_dylink_global_var \
 test_dylink_global_var_modded \
 test_dylink_i64 \
 test_dylink_i64_b \
 test_dylink_i64_c \
 test_dylink_iostream \
 test_dylink_jslib \
 test_dylink_many_postsets \
 test_dylink_memory_growth \
 test_dylink_no_export \
 test_dylink_postsets_chunking \
 test_dylink_printfs \
 test_dylink_rtti \
 test_dylink_safe_heap \
 test_dylink_spaghetti \
 test_dylink_static_funcpointer_float \
 test_dylink_static_funcpointers \
 test_dylink_stdlib \
 test_dylink_zlib \
 test_em_js_linked \
 test_main_module_static_align \
 test_relocatable_void_function \
 test_safe_stack_dylink \
 test_stack_placement_pic
ERRORS_other += \
 test_bad_function_pointer_cast \
 test_binaryen_ctors \
 test_dlopen_rtld_global \
 test_dlsym_rtld_default \
 test_export_aliasee \
 test_ld_library_path \
 test_main_module_without_exceptions_message \
 test_main_module_without_main \
 test_minimal_dynamic

# requires EH functions renaming bugfix (see bug#975069)
FAILS_wasm += \
 test_*_eh \
 test_bad_typeid \
 test_dylink_i64_invoke \
 test_dylink_raii_exceptions \
 test_exceptions \
 test_exceptions_2 \
 test_exceptions_3 \
 test_exceptions_alias \
 test_exceptions_allowed \
 test_exceptions_allowed_2 \
 test_exceptions_allowed_uncaught \
 test_exceptions_convert \
 test_exceptions_custom \
 test_exceptions_destroy_virtual \
 test_exceptions_libcxx \
 test_exceptions_minimal_runtime \
 test_exceptions_multi \
 test_exceptions_multiple_inherit \
 test_exceptions_multiple_inherit_rethrow \
 test_exceptions_primary \
 test_exceptions_resume \
 test_exceptions_rethrow \
 test_exceptions_simplify_cfg \
 test_exceptions_std \
 test_exceptions_typed \
 test_exceptions_uncaught_2 \
 test_exceptions_uncaught \
 test_exceptions_uncaught_count \
 test_exceptions_virtual_inheritance
FAILS_wasm0 += \
 test_exceptions_refcount
FAILS_other += \
 test_locale_wrong \
 test_metadce_cxx_except \
 test_metadce_cxx_mangle \
 test_no_legalize_js_ffi \
 test_only_force_stdlibs_2 \
 test_wasm_backend_lto_libcxx_noexcept

# requires bugfix for AssertionError:
# JS subprocess failed (/usr/bin/nodejs src.js): 7.  Output:
# Assertion failed: failure to getMemory
FAILS_wasm0 += \
 test_dylink_basics_no_modify

# requires bugfix for AssertionError:
# JS subprocess failed (/usr/bin/nodejs test_nodefs_home.js): 1.  Output:
# exception thrown: Error: No such file or directory,Error
FAILS_wasm += \
 test_fs_nodefs_home

# requires bugfix for error: undefined symbol: ...
FAILS_wasm += \
 test_i64_invoke_bigint \
 test_longjmp \
 test_longjmp2 \
 test_longjmp2_main_module \
 test_longjmp3 \
 test_longjmp4 \
 test_longjmp_exc \
 test_longjmp_funcptr \
 test_longjmp_i64 \
 test_longjmp_repeat \
 test_longjmp_stacked \
 test_longjmp_throw \
 test_longjmp_unwind \
 test_pthread_exceptions \
 test_setjmp_many \
 test_setjmp_many_2 \
 test_setjmp_noleak \
 test_siglongjmp
FAILS_other += \
 test_exception_settings \
 test_f_exception \
 test_fignore_exceptions

# requires bugfix for FileNotFoundError:
# [Errno 2] No such file or directory: 'emcc'
FAILS_other += \
 test_scons

# requires bugfix for FileNotFoundError:
# [Errno 2] No such file or directory: '/usr/share/emscripten/emcmake'
FAILS_other += \
 test_cmake_stdproperty

# requires bugfix for AssertionError: Unexpected difference: ...
FAILS_other += \
 test_metadce_hello_main_module_2

# requires bugfix for AssertionError: subprocess exited with non-zero return code(1):
# `emcc /usr/share/emscripten/tests/hello_world.cpp -Wl,--no-check-features,-mllvm,-debug`
#  * wasm-ld (LLVM option parsing): Unknown command line argument '-debug'
FAILS_other += \
 test_supported_linker_flags

# requires bugfix for AssertionError: subprocess exited with non-zero return code(1):
# `emcc -nostdlib++ /<<PKGBUILDDIR>>/tests/other/test_split_main_module.c
# -o test_split_main_module.js -Werror
# -g -sMAIN_MODULE=2 -sEXPORTED_FUNCTIONS=[_printf] -sSPLIT_MODULE=1
# -Wno-experimental --embed-file libhello.wasm
# --post-js /<<PKGBUILDDIR>>/tests/other/test_split_module.post.js
# -sINITIAL_TABLE=16
# -I. -I/<<PKGBUILDDIR>>/tests/other -I/<<PKGBUILDDIR>>/tests/other/include`
FAILS_other += \
 test_split_main_module

# avoid unimportant mode causing multiple failures: strict
CHECK_MODES_WASMX = wasm0 wasm1 wasm2 wasm3 wasms wasmz
CHECK_MODES_WASMJS = wasm2js1 wasm2js2 wasm2js3 wasm2jss wasm2jsz

# maybe requires setting EMSCRIPTEN_TOOLPATH
FAILS_other += \
 test_emscons

# requires bugfix for TypeError:
# Cannot read property 'toString' of undefined
FAILS_other += \
 test_dlopen_bad_flags \
 test_dlsym_rtld_default_js_symbol

# expects smaller output
FAILS_wasm1 += \
 test_emscripten_lazy_load_code_unconditional
FAILS_other += \
 test_function_exports_are_small \
 test_js_function_names_are_minified \
 test_minimal_runtime_code_size_*

# needs node module wasm2c
FAILS_wasmX_wasm2c += \
 test_autodebug_wasm_standalone \
 test_cube2hash_standalone \
 test_longjmp_standalone \
 test_posixtime_standalone
FAILS_other += \
 test_wasm2c_reactor \

NONSCRIPT_EXECUTABLE = \
 system/include/libcxx/readme.txt \
 system/lib/libcxx/readme.txt \
 tests/other/wasm_sourcemap/foo.wasm \
 tests/other/wasm_sourcemap_dead/t.wasm \
 tools/system_libs.py

SCRIPT_NOT_EXECUTABLE = \
 src/compiler.js \
 tests/embind/build_benchmark \
 third_party/uglify-js/test/beautify.js \
 third_party/uglify-js/test/testparser.js \
 third_party/uglify-js/tmp/test.js \
 tools/js-optimizer.js \
 tools/preprocessor.js \
 tools/source-maps/sourcemap2json.js \
 tools/source-maps/sourcemapper.js

%:
	dh $@

# refresh upstream version hints from Debian package
override_dh_auto_configure: $(SOURCE_MAP_MIN_JS) $(NEON_H)
	cp -f emscripten-version.txt emscripten-version.txt.orig
	echo $(DEB_VERSION_UPSTREAM_ORIG) > emscripten-version.txt

=== debian/tests/control ===
Test-Command:
 export EM_CACHE=$(pwd)/debian/em_cache &&
 mkdir -p $EM_CACHE &&
 emcc -v &&
 emcc /usr/share/emscripten/tests/hello_world.c &&
 eslint --no-eslintrc --quiet --env browser --format unix a.out.js &&
 emcc -O3 /usr/share/emscripten/tests/hello_world.c &&
 eslint --no-eslintrc --quiet --env browser --format unix a.out.js
Restrictions: allow-stderr
Depends:
 emscripten,
 eslint,

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan
# post-update: debian/rules get-source-map-footer

opts=\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/,\
repacksuffix=~dfsg,\
dversionmangle=auto \
https://github.com/emscripten-core/emscripten/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@
